Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90	(revision 5141)
@@ -1243,13 +1230,13 @@
 
         IF (i>1) THEN
-          dhdp = (h(ij,i)-h(ij,i-1))/(p(ij,i-1)-p(ij,i))
+          dhdp = (h(ij, i) - h(ij, i - 1)) / (p(ij, i - 1) - p(ij, i))
           dhdp = max(dhdp, 10.0)
-          mp(ij, i) = 100.*ginv*lv(ij, i)*sigd*evap(ij, i)/dhdp
-          mp(ij, i) = max(mp(ij,i), 0.0)
+          mp(ij, i) = 100. * ginv * lv(ij, i) * sigd * evap(ij, i) / dhdp
+          mp(ij, i) = max(mp(ij, i), 0.0)
 
           ! ***   Add small amount of inertia to downdraft              ***
 
-          fac = 20.0/(ph(ij,i-1)-ph(ij,i))
-          mp(ij, i) = (fac*mp(ij,i+1)+mp(ij,i))/(1.+fac)
+          fac = 20.0 / (ph(ij, i - 1) - ph(ij, i))
+          mp(ij, i) = (fac * mp(ij, i + 1) + mp(ij, i)) / (1. + fac)
 
           ! ***      Force mp to decrease linearly to zero
@@ -1258,8 +1245,8 @@
           ! ***
 
-          IF (p(ij,i)>(0.949*p(ij,1))) THEN
+          IF (p(ij, i)>(0.949 * p(ij, 1))) THEN
             jtt(ij) = max(jtt(ij), i)
-            mp(ij, i) = mp(ij, jtt(ij))*(p(ij,1)-p(ij,i))/ &
-              (p(ij,1)-p(ij,jtt(ij)))
+            mp(ij, i) = mp(ij, jtt(ij)) * (p(ij, 1) - p(ij, i)) / &
+                    (p(ij, 1) - p(ij, jtt(ij)))
           END IF
         END IF
@@ -1271,38 +1258,38 @@
             qstm = qs(ij, 1)
           ELSE
-            qstm = qs(ij, i-1)
+            qstm = qs(ij, i - 1)
           END IF
-          IF (mp(ij,i)>mp(ij,i+1)) THEN
-            rat = mp(ij, i+1)/mp(ij, i)
-            qp(ij, i) = qp(ij, i+1)*rat + q(ij, i)*(1.0-rat) + &
-              100.*ginv*sigd*(ph(ij,i)-ph(ij,i+1))*(evap(ij,i)/mp(ij,i))
-            up(ij, i) = up(ij, i+1)*rat + u(ij, i)*(1.-rat)
-            vp(ij, i) = vp(ij, i+1)*rat + v(ij, i)*(1.-rat)
+          IF (mp(ij, i)>mp(ij, i + 1)) THEN
+            rat = mp(ij, i + 1) / mp(ij, i)
+            qp(ij, i) = qp(ij, i + 1) * rat + q(ij, i) * (1.0 - rat) + &
+                    100. * ginv * sigd * (ph(ij, i) - ph(ij, i + 1)) * (evap(ij, i) / mp(ij, i))
+            up(ij, i) = up(ij, i + 1) * rat + u(ij, i) * (1. - rat)
+            vp(ij, i) = vp(ij, i + 1) * rat + v(ij, i) * (1. - rat)
           ELSE
-            IF (mp(ij,i+1)>0.0) THEN
-              qp(ij, i) = (gz(ij,i+1)-gz(ij,i)+qp(ij,i+1)*(lv(ij,i+1)+t(ij, &
-                i+1)*(cl-cpd))+cpd*(t(ij,i+1)-t(ij, &
-                i)))/(lv(ij,i)+t(ij,i)*(cl-cpd))
-              up(ij, i) = up(ij, i+1)
-              vp(ij, i) = vp(ij, i+1)
+            IF (mp(ij, i + 1)>0.0) THEN
+              qp(ij, i) = (gz(ij, i + 1) - gz(ij, i) + qp(ij, i + 1) * (lv(ij, i + 1) + t(ij, &
+                      i + 1) * (cl - cpd)) + cpd * (t(ij, i + 1) - t(ij, &
+                      i))) / (lv(ij, i) + t(ij, i) * (cl - cpd))
+              up(ij, i) = up(ij, i + 1)
+              vp(ij, i) = vp(ij, i + 1)
             END IF
           END IF
-          qp(ij, i) = min(qp(ij,i), qstm)
-          qp(ij, i) = max(qp(ij,i), 0.0)
+          qp(ij, i) = min(qp(ij, i), qstm)
+          qp(ij, i) = max(qp(ij, i), 0.0)
         END IF
       END IF
     END DO
-899 END DO
-
+  899 END DO
 
 END SUBROUTINE cv_unsat
 
 SUBROUTINE cv_yield(nloc, ncum, nd, nk, icb, inb, delt, t, q, u, v, gz, p, &
-    ph, h, hp, lv, cpn, ep, clw, frac, m, mp, qp, up, vp, wt, water, evap, &
-    ment, qent, uent, vent, nent, elij, tv, tvp, iflag, wd, qprime, tprime, &
-    precip, cbmf, ft, fq, fu, fv, ma, qcondc)
+        ph, h, hp, lv, cpn, ep, clw, frac, m, mp, qp, up, vp, wt, water, evap, &
+        ment, qent, uent, vent, nent, elij, tv, tvp, iflag, wd, qprime, tprime, &
+        precip, cbmf, ft, fq, fu, fv, ma, qcondc)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -1314,5 +1301,5 @@
   REAL t(nloc, nd), q(nloc, nd), u(nloc, nd), v(nloc, nd)
   REAL gz(nloc, nd)
-  REAL p(nloc, nd), ph(nloc, nd+1), h(nloc, nd)
+  REAL p(nloc, nd), ph(nloc, nd + 1), h(nloc, nd)
   REAL hp(nloc, nd), lv(nloc, nd)
   REAL cpn(nloc, nd), ep(nloc, nd), clw(nloc, nd), frac(nloc)
@@ -1344,5 +1331,5 @@
   ! -- initializations:
 
-  delti = 1.0/delt
+  delti = 1.0 / delt
 
   DO i = 1, ncum
@@ -1356,5 +1343,5 @@
       fv(i, k) = 0.0
       fq(i, k) = 0.0
-      lvcp(i, k) = lv(i, k)/cpn(i, k)
+      lvcp(i, k) = lv(i, k) / cpn(i, k)
       qcondc(i, k) = 0.0 ! cld
       qcond(i, k) = 0.0 ! cld
@@ -1371,5 +1358,5 @@
       ! c     &                /(rowl*g)
       ! c            precip(i)=precip(i)*delt/86400.
-      precip(i) = wt(i, 1)*sigd*water(i, 1)*86400/g
+      precip(i) = wt(i, 1) * sigd * water(i, 1) * 86400 / g
     END IF
   END DO
@@ -1380,7 +1367,7 @@
 
   DO i = 1, ncum
-    wd(i) = betad*abs(mp(i,icb(i)))*0.01*rrd*t(i, icb(i))/(sigd*p(i,icb(i)))
-    qprime(i) = 0.5*(qp(i,1)-q(i,1))
-    tprime(i) = lv0*qprime(i)/cpd
+    wd(i) = betad * abs(mp(i, icb(i))) * 0.01 * rrd * t(i, icb(i)) / (sigd * p(i, icb(i)))
+    qprime(i) = 0.5 * (qp(i, 1) - q(i, 1))
+    tprime(i) = lv0 * qprime(i) / cpd
   END DO
 
@@ -1389,5 +1376,5 @@
 
   DO i = 1, ncum
-    work(i) = 0.01/(ph(i,1)-ph(i,2))
+    work(i) = 0.01 / (ph(i, 1) - ph(i, 2))
     am(i) = 0.0
   END DO
@@ -1400,24 +1387,24 @@
   END DO
   DO i = 1, ncum
-    IF ((g*work(i)*am(i))>=delti) iflag(i) = 1
-    ft(i, 1) = ft(i, 1) + g*work(i)*am(i)*(t(i,2)-t(i,1)+(gz(i,2)-gz(i, &
-      1))/cpn(i,1))
-    ft(i, 1) = ft(i, 1) - lvcp(i, 1)*sigd*evap(i, 1)
-    ft(i, 1) = ft(i, 1) + sigd*wt(i, 2)*(cl-cpd)*water(i, 2)*(t(i,2)-t(i,1))* &
-      work(i)/cpn(i, 1)
-    fq(i, 1) = fq(i, 1) + g*mp(i, 2)*(qp(i,2)-q(i,1))*work(i) + &
-      sigd*evap(i, 1)
-    fq(i, 1) = fq(i, 1) + g*am(i)*(q(i,2)-q(i,1))*work(i)
-    fu(i, 1) = fu(i, 1) + g*work(i)*(mp(i,2)*(up(i,2)-u(i,1))+am(i)*(u(i, &
-      2)-u(i,1)))
-    fv(i, 1) = fv(i, 1) + g*work(i)*(mp(i,2)*(vp(i,2)-v(i,1))+am(i)*(v(i, &
-      2)-v(i,1)))
+    IF ((g * work(i) * am(i))>=delti) iflag(i) = 1
+    ft(i, 1) = ft(i, 1) + g * work(i) * am(i) * (t(i, 2) - t(i, 1) + (gz(i, 2) - gz(i, &
+            1)) / cpn(i, 1))
+    ft(i, 1) = ft(i, 1) - lvcp(i, 1) * sigd * evap(i, 1)
+    ft(i, 1) = ft(i, 1) + sigd * wt(i, 2) * (cl - cpd) * water(i, 2) * (t(i, 2) - t(i, 1)) * &
+            work(i) / cpn(i, 1)
+    fq(i, 1) = fq(i, 1) + g * mp(i, 2) * (qp(i, 2) - q(i, 1)) * work(i) + &
+            sigd * evap(i, 1)
+    fq(i, 1) = fq(i, 1) + g * am(i) * (q(i, 2) - q(i, 1)) * work(i)
+    fu(i, 1) = fu(i, 1) + g * work(i) * (mp(i, 2) * (up(i, 2) - u(i, 1)) + am(i) * (u(i, &
+            2) - u(i, 1)))
+    fv(i, 1) = fv(i, 1) + g * work(i) * (mp(i, 2) * (vp(i, 2) - v(i, 1)) + am(i) * (v(i, &
+            2) - v(i, 1)))
   END DO
   DO j = 2, nl
     DO i = 1, ncum
       IF (j<=inb(i)) THEN
-        fq(i, 1) = fq(i, 1) + g*work(i)*ment(i, j, 1)*(qent(i,j,1)-q(i,1))
-        fu(i, 1) = fu(i, 1) + g*work(i)*ment(i, j, 1)*(uent(i,j,1)-u(i,1))
-        fv(i, 1) = fv(i, 1) + g*work(i)*ment(i, j, 1)*(vent(i,j,1)-v(i,1))
+        fq(i, 1) = fq(i, 1) + g * work(i) * ment(i, j, 1) * (qent(i, j, 1) - q(i, 1))
+        fu(i, 1) = fu(i, 1) + g * work(i) * ment(i, j, 1) * (uent(i, j, 1) - u(i, 1))
+        fv(i, 1) = fv(i, 1) + g * work(i) * ment(i, j, 1) * (vent(i, j, 1) - v(i, 1))
       END IF
     END DO
@@ -1443,5 +1430,5 @@
     DO k = i + 1, nl + 1
       DO ij = 1, ncum
-        IF ((i>=nk(ij)) .AND. (i<=inb(ij)) .AND. (k<=(inb(ij)+1))) THEN
+        IF ((i>=nk(ij)) .AND. (i<=inb(ij)) .AND. (k<=(inb(ij) + 1))) THEN
           amp1(ij) = amp1(ij) + m(ij, k)
         END IF
@@ -1452,5 +1439,5 @@
       DO j = i + 1, nl + 1
         DO ij = 1, ncum
-          IF ((j<=(inb(ij)+1)) .AND. (i<=inb(ij))) THEN
+          IF ((j<=(inb(ij) + 1)) .AND. (i<=inb(ij))) THEN
             amp1(ij) = amp1(ij) + ment(ij, k, j)
           END IF
@@ -1470,20 +1457,20 @@
     DO ij = 1, ncum
       IF (i<=inb(ij)) THEN
-        dpinv = 0.01/(ph(ij,i)-ph(ij,i+1))
-        cpinv = 1.0/cpn(ij, i)
-
-        ft(ij, i) = ft(ij, i) + g*dpinv*(amp1(ij)*(t(ij,i+1)-t(ij, &
-          i)+(gz(ij,i+1)-gz(ij,i))*cpinv)-ad(ij)*(t(ij,i)-t(ij, &
-          i-1)+(gz(ij,i)-gz(ij,i-1))*cpinv)) - sigd*lvcp(ij, i)*evap(ij, i)
-        ft(ij, i) = ft(ij, i) + g*dpinv*ment(ij, i, i)*(hp(ij,i)-h(ij,i)+t(ij &
-          ,i)*(cpv-cpd)*(q(ij,i)-qent(ij,i,i)))*cpinv
-        ft(ij, i) = ft(ij, i) + sigd*wt(ij, i+1)*(cl-cpd)*water(ij, i+1)*(t( &
-          ij,i+1)-t(ij,i))*dpinv*cpinv
-        fq(ij, i) = fq(ij, i) + g*dpinv*(amp1(ij)*(q(ij,i+1)-q(ij, &
-          i))-ad(ij)*(q(ij,i)-q(ij,i-1)))
-        fu(ij, i) = fu(ij, i) + g*dpinv*(amp1(ij)*(u(ij,i+1)-u(ij, &
-          i))-ad(ij)*(u(ij,i)-u(ij,i-1)))
-        fv(ij, i) = fv(ij, i) + g*dpinv*(amp1(ij)*(v(ij,i+1)-v(ij, &
-          i))-ad(ij)*(v(ij,i)-v(ij,i-1)))
+        dpinv = 0.01 / (ph(ij, i) - ph(ij, i + 1))
+        cpinv = 1.0 / cpn(ij, i)
+
+        ft(ij, i) = ft(ij, i) + g * dpinv * (amp1(ij) * (t(ij, i + 1) - t(ij, &
+                i) + (gz(ij, i + 1) - gz(ij, i)) * cpinv) - ad(ij) * (t(ij, i) - t(ij, &
+                i - 1) + (gz(ij, i) - gz(ij, i - 1)) * cpinv)) - sigd * lvcp(ij, i) * evap(ij, i)
+        ft(ij, i) = ft(ij, i) + g * dpinv * ment(ij, i, i) * (hp(ij, i) - h(ij, i) + t(ij &
+                , i) * (cpv - cpd) * (q(ij, i) - qent(ij, i, i))) * cpinv
+        ft(ij, i) = ft(ij, i) + sigd * wt(ij, i + 1) * (cl - cpd) * water(ij, i + 1) * (t(&
+                ij, i + 1) - t(ij, i)) * dpinv * cpinv
+        fq(ij, i) = fq(ij, i) + g * dpinv * (amp1(ij) * (q(ij, i + 1) - q(ij, &
+                i)) - ad(ij) * (q(ij, i) - q(ij, i - 1)))
+        fu(ij, i) = fu(ij, i) + g * dpinv * (amp1(ij) * (u(ij, i + 1) - u(ij, &
+                i)) - ad(ij) * (u(ij, i) - u(ij, i - 1)))
+        fv(ij, i) = fv(ij, i) + g * dpinv * (amp1(ij) * (v(ij, i + 1) - v(ij, &
+                i)) - ad(ij) * (v(ij, i) - v(ij, i - 1)))
       END IF
     END DO
@@ -1491,14 +1478,14 @@
       DO ij = 1, ncum
         IF (i<=inb(ij)) THEN
-          awat = elij(ij, k, i) - (1.-ep(ij,i))*clw(ij, i)
+          awat = elij(ij, k, i) - (1. - ep(ij, i)) * clw(ij, i)
           awat = max(awat, 0.0)
-          fq(ij, i) = fq(ij, i) + g*dpinv*ment(ij, k, i)*(qent(ij,k,i)-awat-q &
-            (ij,i))
-          fu(ij, i) = fu(ij, i) + g*dpinv*ment(ij, k, i)*(uent(ij,k,i)-u(ij,i &
-            ))
-          fv(ij, i) = fv(ij, i) + g*dpinv*ment(ij, k, i)*(vent(ij,k,i)-v(ij,i &
-            ))
+          fq(ij, i) = fq(ij, i) + g * dpinv * ment(ij, k, i) * (qent(ij, k, i) - awat - q &
+                  (ij, i))
+          fu(ij, i) = fu(ij, i) + g * dpinv * ment(ij, k, i) * (uent(ij, k, i) - u(ij, i &
+                  ))
+          fv(ij, i) = fv(ij, i) + g * dpinv * ment(ij, k, i) * (vent(ij, k, i) - v(ij, i &
+                  ))
           ! (saturated updrafts resulting from mixing)               ! cld
-          qcond(ij, i) = qcond(ij, i) + (elij(ij,k,i)-awat) ! cld
+          qcond(ij, i) = qcond(ij, i) + (elij(ij, k, i) - awat) ! cld
           nqcond(ij, i) = nqcond(ij, i) + 1. ! cld
         END IF
@@ -1508,10 +1495,10 @@
       DO ij = 1, ncum
         IF ((i<=inb(ij)) .AND. (k<=inb(ij))) THEN
-          fq(ij, i) = fq(ij, i) + g*dpinv*ment(ij, k, i)*(qent(ij,k,i)-q(ij,i &
-            ))
-          fu(ij, i) = fu(ij, i) + g*dpinv*ment(ij, k, i)*(uent(ij,k,i)-u(ij,i &
-            ))
-          fv(ij, i) = fv(ij, i) + g*dpinv*ment(ij, k, i)*(vent(ij,k,i)-v(ij,i &
-            ))
+          fq(ij, i) = fq(ij, i) + g * dpinv * ment(ij, k, i) * (qent(ij, k, i) - q(ij, i &
+                  ))
+          fu(ij, i) = fu(ij, i) + g * dpinv * ment(ij, k, i) * (uent(ij, k, i) - u(ij, i &
+                  ))
+          fv(ij, i) = fv(ij, i) + g * dpinv * ment(ij, k, i) * (vent(ij, k, i) - v(ij, i &
+                  ))
         END IF
       END DO
@@ -1519,10 +1506,10 @@
     DO ij = 1, ncum
       IF (i<=inb(ij)) THEN
-        fq(ij, i) = fq(ij, i) + sigd*evap(ij, i) + g*(mp(ij,i+1)*(qp(ij, &
-          i+1)-q(ij,i))-mp(ij,i)*(qp(ij,i)-q(ij,i-1)))*dpinv
-        fu(ij, i) = fu(ij, i) + g*(mp(ij,i+1)*(up(ij,i+1)-u(ij, &
-          i))-mp(ij,i)*(up(ij,i)-u(ij,i-1)))*dpinv
-        fv(ij, i) = fv(ij, i) + g*(mp(ij,i+1)*(vp(ij,i+1)-v(ij, &
-          i))-mp(ij,i)*(vp(ij,i)-v(ij,i-1)))*dpinv
+        fq(ij, i) = fq(ij, i) + sigd * evap(ij, i) + g * (mp(ij, i + 1) * (qp(ij, &
+                i + 1) - q(ij, i)) - mp(ij, i) * (qp(ij, i) - q(ij, i - 1))) * dpinv
+        fu(ij, i) = fu(ij, i) + g * (mp(ij, i + 1) * (up(ij, i + 1) - u(ij, &
+                i)) - mp(ij, i) * (up(ij, i) - u(ij, i - 1))) * dpinv
+        fv(ij, i) = fv(ij, i) + g * (mp(ij, i + 1) * (vp(ij, i + 1) - v(ij, &
+                i)) - mp(ij, i) * (vp(ij, i) - v(ij, i - 1))) * dpinv
         ! (saturated downdrafts resulting from mixing)               ! cld
         DO k = i + 1, inb(ij) ! cld
@@ -1531,14 +1518,14 @@
         END DO ! cld
         ! (particular case: no detraining level is found)            ! cld
-        IF (nent(ij,i)==0) THEN ! cld
-          qcond(ij, i) = qcond(ij, i) + (1.-ep(ij,i))*clw(ij, i) ! cld
+        IF (nent(ij, i)==0) THEN ! cld
+          qcond(ij, i) = qcond(ij, i) + (1. - ep(ij, i)) * clw(ij, i) ! cld
           nqcond(ij, i) = nqcond(ij, i) + 1. ! cld
         END IF ! cld
-        IF (nqcond(ij,i)/=0.) THEN ! cld
-          qcond(ij, i) = qcond(ij, i)/nqcond(ij, i) ! cld
+        IF (nqcond(ij, i)/=0.) THEN ! cld
+          qcond(ij, i) = qcond(ij, i) / nqcond(ij, i) ! cld
         END IF ! cld
       END IF
     END DO
-1500 END DO
+  1500 END DO
 
   ! *** Adjust tendencies at top of convection layer to reflect  ***
@@ -1547,21 +1534,21 @@
   DO ij = 1, ncum
     fqold = fq(ij, inb(ij))
-    fq(ij, inb(ij)) = fq(ij, inb(ij))*(1.-frac(ij))
-    fq(ij, inb(ij)-1) = fq(ij, inb(ij)-1) + frac(ij)*fqold*((ph(ij, &
-      inb(ij))-ph(ij,inb(ij)+1))/(ph(ij,inb(ij)-1)-ph(ij, &
-      inb(ij))))*lv(ij, inb(ij))/lv(ij, inb(ij)-1)
+    fq(ij, inb(ij)) = fq(ij, inb(ij)) * (1. - frac(ij))
+    fq(ij, inb(ij) - 1) = fq(ij, inb(ij) - 1) + frac(ij) * fqold * ((ph(ij, &
+            inb(ij)) - ph(ij, inb(ij) + 1)) / (ph(ij, inb(ij) - 1) - ph(ij, &
+            inb(ij)))) * lv(ij, inb(ij)) / lv(ij, inb(ij) - 1)
     ftold = ft(ij, inb(ij))
-    ft(ij, inb(ij)) = ft(ij, inb(ij))*(1.-frac(ij))
-    ft(ij, inb(ij)-1) = ft(ij, inb(ij)-1) + frac(ij)*ftold*((ph(ij, &
-      inb(ij))-ph(ij,inb(ij)+1))/(ph(ij,inb(ij)-1)-ph(ij, &
-      inb(ij))))*cpn(ij, inb(ij))/cpn(ij, inb(ij)-1)
+    ft(ij, inb(ij)) = ft(ij, inb(ij)) * (1. - frac(ij))
+    ft(ij, inb(ij) - 1) = ft(ij, inb(ij) - 1) + frac(ij) * ftold * ((ph(ij, &
+            inb(ij)) - ph(ij, inb(ij) + 1)) / (ph(ij, inb(ij) - 1) - ph(ij, &
+            inb(ij)))) * cpn(ij, inb(ij)) / cpn(ij, inb(ij) - 1)
     fuold = fu(ij, inb(ij))
-    fu(ij, inb(ij)) = fu(ij, inb(ij))*(1.-frac(ij))
-    fu(ij, inb(ij)-1) = fu(ij, inb(ij)-1) + frac(ij)*fuold*((ph(ij, &
-      inb(ij))-ph(ij,inb(ij)+1))/(ph(ij,inb(ij)-1)-ph(ij,inb(ij))))
+    fu(ij, inb(ij)) = fu(ij, inb(ij)) * (1. - frac(ij))
+    fu(ij, inb(ij) - 1) = fu(ij, inb(ij) - 1) + frac(ij) * fuold * ((ph(ij, &
+            inb(ij)) - ph(ij, inb(ij) + 1)) / (ph(ij, inb(ij) - 1) - ph(ij, inb(ij))))
     fvold = fv(ij, inb(ij))
-    fv(ij, inb(ij)) = fv(ij, inb(ij))*(1.-frac(ij))
-    fv(ij, inb(ij)-1) = fv(ij, inb(ij)-1) + frac(ij)*fvold*((ph(ij, &
-      inb(ij))-ph(ij,inb(ij)+1))/(ph(ij,inb(ij)-1)-ph(ij,inb(ij))))
+    fv(ij, inb(ij)) = fv(ij, inb(ij)) * (1. - frac(ij))
+    fv(ij, inb(ij) - 1) = fv(ij, inb(ij) - 1) + frac(ij) * fvold * ((ph(ij, &
+            inb(ij)) - ph(ij, inb(ij) + 1)) / (ph(ij, inb(ij) - 1) - ph(ij, inb(ij))))
   END DO
 
@@ -1574,20 +1561,20 @@
     vav(ij) = 0.0
     DO i = 1, inb(ij)
-      ents(ij) = ents(ij) + (cpn(ij,i)*ft(ij,i)+lv(ij,i)*fq(ij,i))*(ph(ij,i)- &
-        ph(ij,i+1))
-      uav(ij) = uav(ij) + fu(ij, i)*(ph(ij,i)-ph(ij,i+1))
-      vav(ij) = vav(ij) + fv(ij, i)*(ph(ij,i)-ph(ij,i+1))
+      ents(ij) = ents(ij) + (cpn(ij, i) * ft(ij, i) + lv(ij, i) * fq(ij, i)) * (ph(ij, i) - &
+              ph(ij, i + 1))
+      uav(ij) = uav(ij) + fu(ij, i) * (ph(ij, i) - ph(ij, i + 1))
+      vav(ij) = vav(ij) + fv(ij, i) * (ph(ij, i) - ph(ij, i + 1))
     END DO
   END DO
   DO ij = 1, ncum
-    ents(ij) = ents(ij)/(ph(ij,1)-ph(ij,inb(ij)+1))
-    uav(ij) = uav(ij)/(ph(ij,1)-ph(ij,inb(ij)+1))
-    vav(ij) = vav(ij)/(ph(ij,1)-ph(ij,inb(ij)+1))
+    ents(ij) = ents(ij) / (ph(ij, 1) - ph(ij, inb(ij) + 1))
+    uav(ij) = uav(ij) / (ph(ij, 1) - ph(ij, inb(ij) + 1))
+    vav(ij) = vav(ij) / (ph(ij, 1) - ph(ij, inb(ij) + 1))
   END DO
   DO ij = 1, ncum
     DO i = 1, inb(ij)
-      ft(ij, i) = ft(ij, i) - ents(ij)/cpn(ij, i)
-      fu(ij, i) = (1.-cu)*(fu(ij,i)-uav(ij))
-      fv(ij, i) = (1.-cu)*(fv(ij,i)-vav(ij))
+      ft(ij, i) = ft(ij, i) - ents(ij) / cpn(ij, i)
+      fu(ij, i) = (1. - cu) * (fu(ij, i) - uav(ij))
+      fv(ij, i) = (1. - cu) * (fv(ij, i) - vav(ij))
     END DO
   END DO
@@ -1595,8 +1582,7 @@
   DO k = 1, nl + 1
     DO i = 1, ncum
-      IF ((q(i,k)+delt*fq(i,k))<0.0) iflag(i) = 10
-    END DO
-  END DO
-
+      IF ((q(i, k) + delt * fq(i, k))<0.0) iflag(i) = 10
+    END DO
+  END DO
 
   DO i = 1, ncum
@@ -1625,5 +1611,5 @@
   DO k = nl, 1, -1
     DO i = 1, ncum
-      ma(i, k) = ma(i, k+1) + m(i, k)
+      ma(i, k) = ma(i, k + 1) + m(i, k)
     END DO
   END DO
@@ -1647,27 +1633,26 @@
       ax(ij, i) = 0. ! cld
       DO j = icb(ij), i ! cld
-        ax(ij, i) = ax(ij, i) + rrd*(tvp(ij,j)-tv(ij,j)) & ! cld
-          *(ph(ij,j)-ph(ij,j+1))/p(ij, j) ! cld
+        ax(ij, i) = ax(ij, i) + rrd * (tvp(ij, j) - tv(ij, j)) & ! cld
+                * (ph(ij, j) - ph(ij, j + 1)) / p(ij, j) ! cld
       END DO ! cld
-      IF (ax(ij,i)>0.0) THEN ! cld
-        wa(ij, i) = sqrt(2.*ax(ij,i)) ! cld
+      IF (ax(ij, i)>0.0) THEN ! cld
+        wa(ij, i) = sqrt(2. * ax(ij, i)) ! cld
       END IF ! cld
     END DO ! cld
     DO i = 1, nl ! cld
-      IF (wa(ij,i)>0.0) &          ! cld
-        siga(ij, i) = mac(ij, i)/wa(ij, i) & ! cld
-        *rrd*tvp(ij, i)/p(ij, i)/100./delta ! cld
-      siga(ij, i) = min(siga(ij,i), 1.0) ! cld
-      qcondc(ij, i) = siga(ij, i)*clw(ij, i)*(1.-ep(ij,i)) & ! cld
-        +(1.-siga(ij,i))*qcond(ij, i) ! cld
+      IF (wa(ij, i)>0.0) &          ! cld
+              siga(ij, i) = mac(ij, i) / wa(ij, i) & ! cld
+                      * rrd * tvp(ij, i) / p(ij, i) / 100. / delta ! cld
+      siga(ij, i) = min(siga(ij, i), 1.0) ! cld
+      qcondc(ij, i) = siga(ij, i) * clw(ij, i) * (1. - ep(ij, i)) & ! cld
+              + (1. - siga(ij, i)) * qcond(ij, i) ! cld
     END DO ! cld
   END DO ! cld
 
-
 END SUBROUTINE cv_yield
 
 SUBROUTINE cv_uncompress(nloc, len, ncum, nd, idcum, iflag, precip, cbmf, ft, &
-    fq, fu, fv, ma, qcondc, iflag1, precip1, cbmf1, ft1, fq1, fu1, fv1, ma1, &
-    qcondc1)
+        fq, fu, fv, ma, qcondc, iflag1, precip1, cbmf1, ft1, fq1, fu1, fv1, ma1, &
+        qcondc1)
   IMPLICIT NONE
 
@@ -1710,5 +1695,4 @@
   END DO
 
-
 END SUBROUTINE cv_uncompress
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cv3param.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cv3param.f90	(revision 5141)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cv3param.f90	(revision 5141)
@@ -0,0 +1,44 @@
+! Replaces cv3param.h
+
+MODULE lmdz_cv3param
+  !------------------------------------------------------------
+  ! Parameters for convectL, iflag_con=3:
+  ! (includes - microphysical parameters,
+  !			- parameters that control the rate of approach
+  !               to quasi-equilibrium)
+  !			- noff & minorig (previously in input of convect1)
+  !------------------------------------------------------------
+  IMPLICIT NONE; PRIVATE
+  PUBLIC sigdz, spfac, pbcrit, ptcrit, elcrit, tlcrit, coef_peel, omtrain, dtovsh, dpbase, &
+          dttrig, dtcrit, tau, beta, alpha, alpha1, T_top_max, tau_stop, noconv_stop, wbmax, &
+          delta, betad, ejectliq, ejectice, flag_wb, flag_epKEorig, cv_flag_feed, noff, minorig, &
+          nl, nlp, nlm
+
+  INTEGER flag_epKEorig
+  REAL flag_wb
+  INTEGER cv_flag_feed
+  INTEGER noff, minorig, nl, nlp, nlm
+  REAL sigdz, spfac
+  REAL pbcrit, ptcrit
+  REAL elcrit, tlcrit
+  REAL coef_peel
+  REAL omtrain
+  REAL dtovsh, dpbase, dttrig
+  REAL dtcrit, tau, beta, alpha, alpha1
+  REAL T_top_max
+  REAL tau_stop, noconv_stop
+  REAL wbmax
+  REAL delta
+  REAL betad
+  REAL ejectliq
+  REAL ejectice
+
+  !$OMP THREADPRIVATE(sigdz, spfac, pbcrit, ptcrit, elcrit, tlcrit, coef_peel, omtrain, dtovsh, dpbase, &
+  !$OMP      dttrig, dtcrit, tau, beta, alpha, alpha1, T_top_max, tau_stop, noconv_stop, wbmax, &
+  !$OMP      delta, betad, ejectliq, ejectice, flag_wb, flag_epKEorig, cv_flag_feed, noff, minorig, &
+  !$OMP      nl, nlp, nlm)
+END MODULE lmdz_cv3param
+
+
+
+
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cvthermo.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cvthermo.f90	(revision 5141)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cvthermo.f90	(revision 5141)
@@ -0,0 +1,17 @@
+! Replaces cvthermo.h
+
+MODULE lmdz_cvthermo
+  IMPLICIT NONE; PRIVATE
+  PUBLIC cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0, clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl  &
+          , clmci, eps, epsi, epsim1, ginv, hrd, grav
+
+  ! Thermodynamical constants for convectL:
+  REAL cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0
+  REAL clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl, clmci
+  REAL eps, epsi, epsim1
+  REAL ginv, hrd
+  REAL grav
+
+  !$OMP THREADPRIVATE(cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0, clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl  &
+  !$OMP      , clmci, eps, epsi, epsim1, ginv, hrd, grav)
+END MODULE lmdz_cvthermo
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_enthalpmix.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_enthalpmix.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_enthalpmix.F90	(revision 5141)
@@ -17,4 +17,5 @@
   ! modified by :  Filiberti M-A 06/2005 vectorisation          *
   ! **************************************************************
+USE lmdz_cvthermo
 
   IMPLICIT NONE
@@ -29,5 +30,4 @@
   ! ===============================================================
 
-  include "cvthermo.h"
   include "YOETHF.h"
   include "YOMCST.h"
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_estatmix.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_estatmix.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_estatmix.F90	(revision 5141)
@@ -18,4 +18,5 @@
   ! modified by :  Filiberti M-A 06/2005 vectorisation              *
   ! ****************************************************************
+USE lmdz_cvthermo
 
   IMPLICIT NONE
@@ -30,5 +31,4 @@
   ! ===============================================================
 
-  include "cvthermo.h"
   include "YOETHF.h"
   include "YOMCST.h"
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3_routines.F90	(revision 5141)
@@ -11,4 +11,5 @@
   USE lmdz_conema3
   USE lmdz_cvflag
+  USE lmdz_cv3param
 
   IMPLICIT NONE
@@ -36,6 +37,4 @@
 !***                 APPROACH TO QUASI-EQUILIBRIUM           ***
 !***                     IT MUST BE LESS THAN 0              ***
-
-  include "cv3param.h"
 
   INTEGER, INTENT(IN)              :: nd
@@ -184,4 +183,5 @@
 SUBROUTINE cv3_incrcount(len, nd, delt, sig)
   USE lmdz_cvflag
+  USE lmdz_cv3param
 
 IMPLICIT NONE
@@ -190,6 +190,4 @@
 !  Increment the counter sig(nd)
 ! =====================================================================
-
-  include "cv3param.h"
 
 !inputs:
@@ -224,4 +222,7 @@
 SUBROUTINE cv3_prelim(len, nd, ndp1, t, q, p, ph, &
                       lv, lf, cpn, tv, gz, h, hm, th)
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -246,8 +247,4 @@
   REAL tvx, tvy ! convect3
   REAL cpx(len, nd)
-
-  include "cvthermo.h"
-  include "cv3param.h"
-
 
 ! ori      do 110 k=1,nlp
@@ -324,4 +321,7 @@
   USE add_phys_tend_mod, ONLY: fl_cor_ebil
   USE lmdz_print_control, ONLY: prt_level
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -340,7 +340,4 @@
 ! - A,B explicitely defined (!...)
 ! ================================================================
-
-  include "cv3param.h"
-  include "cvthermo.h"
 
 !inputs:
@@ -699,4 +696,7 @@
 #endif
 #endif
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -713,7 +713,4 @@
 !    - if icbs=icb, compute also tp(icb+1),tvp(icb+1) & clw(icb+1)
 ! ----------------------------------------------------------------
-
-  include "cvthermo.h"
-  include "cv3param.h"
 
 ! inputs:
@@ -1146,4 +1143,6 @@
 SUBROUTINE cv3_trigger(len, nd, icb, plcl, p, th, tv, tvp, thnk, &
                        pbase, buoybase, iflag, sig, w0)
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -1162,6 +1161,4 @@
 ! -> the buoyancy below cloud base not (yet) set to the cloud base buoyancy
 ! -------------------------------------------------------------------
-
-  include "cv3param.h"
 
 ! input:
@@ -1278,7 +1275,8 @@
 #endif
 #endif
+
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
 !inputs:
@@ -1487,4 +1485,7 @@
 #endif
 USE lmdz_cvflag
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -1507,6 +1508,4 @@
 ! ---------------------------------------------------------------------
 
-  include "cvthermo.h"
-  include "cv3param.h"
   include "YOMCST2.h"
 
@@ -2509,7 +2508,9 @@
 END SUBROUTINE cv3_undilute2
 
-SUBROUTINE cv3_closure(nloc, ncum, nd, icb, inb, &
-                       pbase, p, ph, tv, buoy, &
+SUBROUTINE cv3_closure(nloc, ncum, nd, icb, inb, pbase, p, ph, tv, buoy, &
                        sig, w0, cape, m, iflag)
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -2519,7 +2520,4 @@
 ! vectorization: S. Bony
 ! ===================================================================
-
-  include "cvthermo.h"
-  include "cv3param.h"
 
 !input:
@@ -2784,4 +2782,7 @@
 #endif
 USE lmdz_cvflag
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
 
@@ -2790,7 +2791,4 @@
 ! - vectorisation de la partie normalisation des flux (do 789...)
 ! ---------------------------------------------------------------------
-
-  include "cvthermo.h"
-  include "cv3param.h"
 
 !inputs:
@@ -3612,9 +3610,8 @@
 #endif
 USE lmdz_cvflag
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-
-  include "cvthermo.h"
-  include "cv3param.h"
 
 !inputs:
@@ -4718,8 +4715,8 @@
 #endif
 USE lmdz_cvflag
+USE lmdz_cvthermo
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cvthermo.h"
-  include "cv3param.h"
 
 !inputs:
@@ -7274,7 +7271,7 @@
                       ep, Vprecip, elij, clw, epmlmMm, eplaMm, &
                       icb, inb)
+  USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
 !inputs:
@@ -7409,7 +7406,7 @@
 #endif
 #endif
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
 !inputs:
@@ -7597,4 +7594,6 @@
                   USE lmdz_conema3
                   USE lmdz_cvflag
+                  USE lmdz_cvthermo
+                  USE lmdz_cv3param
 
         IMPLICIT NONE
@@ -7605,7 +7604,4 @@
         ! qui en depend
         ! Toutes les autres variables fn de ep sont calculees plus bas.
-
-  include "cvthermo.h"
-  include "cv3param.h"  
 
 ! inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_compress.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_compress.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_compress.F90	(revision 5141)
@@ -41,7 +41,7 @@
 #endif
   USE lmdz_abort_physic, ONLY: abort_physic
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
   ! inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_uncompress.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_uncompress.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3a_uncompress.F90	(revision 5141)
@@ -56,7 +56,7 @@
   USE infotrac_phy, ONLY: ntraciso=>ntiso
 #endif
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
   ! inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3p_mixing.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3p_mixing.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv3p_mixing.F90	(revision 5141)
@@ -40,8 +40,9 @@
 #endif
 USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-  include "cvthermo.h"
-  include "cv3param.h"
   include "YOMCST2.h"
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv_driver.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv_driver.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/cv_driver.F90	(revision 5141)
@@ -42,4 +42,7 @@
 #endif
 #endif
+USE lmdz_cv30, ONLY: cv30_param, cv30_prelim, cv30_feed, cv30_undilute1, cv30_trigger, cv30_compress, cv30_undilute2, &
+          cv30_closure, cv30_epmax_fn_cape, cv30_mixing, cv30_unsat, cv30_yield, cv30_tracer, cv30_uncompress
+
   IMPLICIT NONE
 
@@ -1261,4 +1264,6 @@
 ! ==================================================================
 SUBROUTINE cv_thermo(iflag_con)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
@@ -1268,5 +1273,4 @@
 
   include "YOMCST.h"
-  include "cvthermo.h"
 
   INTEGER iflag_con
